Subject: [spfbis] [Technical Errata Reported] RFC7208 (5550)

From: RFC Errata System <[email-masked]>
Date: Fri, 9 Nov 2018 08:59:20 -0800 (PST)

The following errata report has been submitted for RFC7208,
"Sender Policy Framework (SPF) for Authorizing Use of Domains in Email, Version 1".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5550

--------------------------------------
Type: Technical
Reported by: Borislav Petrov <[email-masked]>

Section: 2.3.

Original Text
-------------
   Note that requirements for the domain presented in the EHLO or HELO
   command are not always clear to the sending party, and SPF verifiers
   have to be prepared for the identity to be an IP address literal (see
   [RFC5321], Section 4.1.3) or simply be malformed.  This SPF check can
   only be performed when the "HELO" string is a valid, multi-label
   domain name.

Corrected Text
--------------

Notes
-----
It looks like that those who have HELO <IP Address> or <malformed> will have result "none" (and pass) but those that have HELO <hostname> and have not yet published their hostname (A record) as allowed sender will get fail. This becomes a very common case for all messages which are DSNs. The whole idea that it is better to have your HELO malformed than a valid hostname which identifies the system is wrong. The point is to fight spam but you actually make it easier for spammers to just have the EHLO malformed and send with <> reverse-path rather than having some proper EHLO/HELO which is subject to other verifications like rDNS, etc.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC7208 (draft-ietf-spfbis-4408bis-21)
--------------------------------------
Title               : Sender Policy Framework (SPF) for Authorizing Use of Domains in Email, Version 1
Publication Date    : April 2014
Author(s)           : S. Kitterman
Category            : PROPOSED STANDARD
Source              : SPF Update
Area                : Applications
Stream              : IETF
Verifying Party     : IESG

---

From: Scott Kitterman <[email-masked]>
Date: Fri, 09 Nov 2018 14:17:41 -0500

My recommendation is that the errata be rejected.

Rationale:

The submitter doesn't follow through what the next steps in the process would 
be and makes incorrect assumptions.

As described in the errata,

HELO/EHLO names that are HELO <IP Address> or <malformed> will have a HELO 
check result of none.  In the case of HELO <hostname>, the claim that if 
<hostname> does not have an A record, the HELO check result will be fail is 
incorrect.

If the HELO is a valid hostname, then the first step would be do a DNS TXT 
lookup to determine if there is a valid SPF record.  If there is no record, 
then the result is none, just like HELO <IP Address> or <malformed>.

If there is an SPF record for the HELO name and the record uses an a:/aaaa: 
mechanism for which no A/AAAA record exists, then the result will be whatever 
is specified based on the qualifier for the 'all' mechanism at the end of the 
record.  This may or may not be fail.

In the latter case, the unanticipated result is a function of an incorrect 
operational configuration, not an issue with the protocol.  It is true that 
publishing an incorrect SPF record can have negative consequences, but that's 
true for all SPF records and nothing related to this text.

Scott K

On Friday, November 09, 2018 08:59:20 AM RFC Errata System wrote:
> It looks like that those who have HELO <IP Address> or <malformed> will have
> result "none" (and pass) but those that have HELO <hostname> and have not
> yet published their hostname (A record) as allowed sender will get fail.
> This becomes a very common case for all messages which are DSNs. The whole
> idea that it is better to have your HELO malformed than a valid hostname
> which identifies the system is wrong. The point is to fight spam but you
> actually make it easier for spammers to just have the EHLO malformed and
> send with <> reverse-path rather than having some proper EHLO/HELO which is
> subject to other verifications like rDNS, etc.
> 
> Instructions:
> -------------
> Title               : Sender Policy Framework (SPF) for Authorizing Use of
> Domains in Email, Version 1 Publication Date    : April 2014
> Author(s)           : S. Kitterman

---

From: "Stuart D. Gathman" <[email-masked]>
Date: Fri, 09 Nov 2018 14:35:15 -0500

+1  Scott K stated it well.  I was going to write something similar.  I 
use an implicit default record of "v=spf1 a" for HELO, which also 
simply gives a neutral result in the case he is concerned about,

---

From: Scott Kitterman <[email-masked]>
Date: Mon, 12 Nov 2018 14:10:08 -0500

After further off-line discussion with the reporter, my recommendation to 
reject this errata is confirmed in my mind.  I think that most of his issue is 
with how various SPF results are used by receivers, which is out of scope of 
RFC 7208.  It does not specify receiver policy.

Scott K

On Friday, November 09, 2018 02:17:41 PM Scott Kitterman wrote:
> The submitter doesn't follow through what the next steps in the process
> would be and makes incorrect assumptions.
> 
> mechanism for which no A/AAAA record exists, then the result will be
> whatever is specified based on the qualifier for the 'all' mechanism at the
> end of the record.  This may or may not be fail.
> 
> publishing an incorrect SPF record can have negative consequences, but
> that's true for all SPF records and nothing related to this text.
> 
> Scott K
> 
> > It looks like that those who have HELO <IP Address> or <malformed> will
> > have result "none" (and pass) but those that have HELO <hostname> and
> > have not yet published their hostname (A record) as allowed sender will
> > get fail. This becomes a very common case for all messages which are
> > DSNs. The whole idea that it is better to have your HELO malformed than a
> > valid hostname which identifies the system is wrong. The point is to
> > fight spam but you actually make it easier for spammers to just have the
> > EHLO malformed and send with <> reverse-path rather than having some
> > proper EHLO/HELO which is subject to other verifications like rDNS, etc.
> > 
> > Instructions:
> > -------------
> _______________________________________________
> spfbis mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/spfbis